Bug 1134914 - debhelper-9.20150628: FTBFS on ARM
Summary: debhelper-9.20150628: FTBFS on ARM
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: debhelper
Version: 27
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Oron Peled
QA Contact: Fedora Extras Quality Assurance
URL: https://koji.fedoraproject.org/koji/t...
Whiteboard:
: 1106129 1459615 (view as bug list)
Depends On:
Blocks: ARMTracker 1161450
TreeView+ depends on / blocked
 
Reported: 2014-08-28 13:01 UTC by Jitka Plesnikova
Modified: 2018-10-16 10:29 UTC (History)
4 users (show)

Fixed In Version: debhelper-11.4-2.fc29 debhelper-11.4-2.fc28 debhelper-11.4-2.fc27 debhelper-11.4-2.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-10-02 19:30:52 UTC


Attachments (Terms of Use)

Description Jitka Plesnikova 2014-08-28 13:01:41 UTC
debhelper can't be rebuild against perl 5.20.

Tests are failing 

+ make test
printf "package Debian::Debhelper::Dh_Version;\n\$version='9.20140613';\n1" > \
	Debian/Debhelper/Dh_Version.pm
./run perl -MTest::Harness -e 'runtests grep { ! /CVS/ && ! /\.svn/ && -f && -x } @ARGV' t/* t/buildsystems/*
t/dh-lib .......................... ok
t/dh_install ...................... ok
t/dh_link ......................... ok
t/override_target ................. ok
t/pod ............................. ok
t/size ............................ ok
t/syntax .......................... ok
#   Failed test 'autoconf/stamp_configure contains extra args'
#   at t/buildsystems/buildsystem_tests line 472.
#     Structures begin differing at:
#          $got->[0] = '--host=arm-linux-gnueabi'
#     $expected->[0] = Does not exist
#   Failed test 'autoconf/stamp_test exists'
#   at t/buildsystems/buildsystem_tests line 477.
#   Failed test 'bld/dir/stamp_configure contains extra args'
#   at t/buildsystems/buildsystem_tests line 472.
#     Structures begin differing at:
#          $got->[0] = '--host=arm-linux-gnueabi'
#     $expected->[0] = '--extra-autoconf-configure-arg'
#   Failed test 'bld/dir/stamp_test exists'
#   at t/buildsystems/buildsystem_tests line 477.
# Looks like you failed 4 tests of 297.
t/buildsystems/buildsystem_tests .. 
Dubious, test returned 4 (wstat 1024, 0x400)
Failed 4/297 subtests 
Test Summary Report
-------------------
t/buildsystems/buildsystem_tests (Wstat: 1024 Tests: 297 Failed: 4)
  Failed tests:  248, 252, 262, 266
  Non-zero exit status: 4
Files=8, Tests=588, 24 wallclock secs ( 0.41 usr  0.03 sys + 15.95 cusr  3.36 csys = 19.75 CPU)
Result: FAIL
Failed 1/8 test programs. 4/588 subtests failed.

Comment 1 Sergio Monteiro Basto 2014-08-28 13:37:18 UTC
build this noarch on arm fails but not on a x86_64 , the problem  is reported upstream but is not simple I built successfully  now 

http://koji.fedoraproject.org/koji/taskinfo?taskID=7474972

*** This bug has been marked as a duplicate of bug 1106129 ***

Comment 2 Sergio Monteiro Basto 2014-08-28 13:41:50 UTC
DEBUG util.py:283:   perl                     x86_64   4:5.18.2-304.fc22

build on rawhide still use perl 5.18.2 , where did you build your package ?

Comment 3 Jitka Plesnikova 2014-08-28 13:51:49 UTC
The build perl-5.20.0-305.fc22 is not in rawhide, it is in f22-perl. It will be merge to rawhide when Perl mass rebuild finished. 

You can find more info on page https://fedoraproject.org/wiki/Changes/perl5.20

Comment 4 Petr Pisar 2014-09-17 11:41:36 UTC
I rebuild this package against perl 5.20 as debhelper-9.20140613-3.fc22. But that used x86_64 builder, so the reported (ARM) bug is still there.

Comment 5 Sergio Monteiro Basto 2014-09-17 11:50:58 UTC
*** Bug 1106129 has been marked as a duplicate of this bug. ***

Comment 6 Sergio Monteiro Basto 2014-09-17 11:53:37 UTC
For reference : 

https://lists.fedoraproject.org/pipermail/devel/2014-February/195746.html

Comment 7 Jaroslav Reznik 2015-03-03 16:15:09 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22

Comment 8 Sergio Monteiro Basto 2015-07-21 00:43:15 UTC
Hi, 
the test fails because dpkg-architecture -qDEB_BUILD_GNU_TYPE and dpkg-architecture -qDEB_HOST_GNU_TYPE have a different result on arm .

Niels Thykier wrote:

I suspect the setup made debhelper believe you were trying to
cross-build the (test) package.

The debhelper "autoconf" build system includes the following piece
(modulo forced line wraps):
"""
# Provide --host only if different from --build, as recommended in
# autotools-dev README.Debian: When provided (even if equal)
# autoconf 2.52+ switches to cross-compiling mode.
if (dpkg_architecture_value("DEB_BUILD_GNU_TYPE")
    ne dpkg_architecture_value("DEB_HOST_GNU_TYPE")) {
        push @opts, "--host=" . dpkg_architecture_value("DEB_HOST_GNU_TYPE");
}
"""

Which, at first glance, fits with the extra option triggering a test
failure.

However, I am not able to figure out why this happens (only) on your arm
box.  This might be related to the remark the mapping of dpkg architecture.
If possible, try to compare the output of the following commands in the
arm box with the build failures:
  dpkg-architecture -qDEB_BUILD_GNU_TYPE
  dpkg-architecture -qDEB_HOST_GNU_TYPE

If they are not byte-for-byte identical, it will currently trigger the
cross-build support and break the test.

I wrote: 

you got it ! [1]
+ dpkg-architecture -qDEB_BUILD_GNU_TYPE
arm-linux-gnu
+ dpkg-architecture -qDEB_HOST_GNU_TYPE
arm-linux-gnueabi

So what is wrong ? is /bin/dpkg-architecture from dpkg-dev  ?

Niels Thykier wrote:

It is indeed from dpkg-dev.  Its results are based on some data files.
On debian these data files are installed via the "dpkg" package itself
and placed in:

/usr/share/dpkg/triplettable
/usr/share/dpkg/cputable
/usr/share/dpkg/ostable
/usr/share/dpkg/abitable

I assume it is similar for Fedora.

I wrote:

cat /usr/share/dpkg/archtable | grep arm 
arm-linux-gnu                   arm
arm-linux-gnueabi               armel

Should I put armel as arm-linux-gnu or arm as arm-linux-gnueabi :) ? 

Niels Thykier wrote:
Unfortunately, I am not very knowledgeable in the exact layout /
contents of these files - I just know they are the basis for the results
of dpkg-architecture.

You might be better served by talking with the dpkg team here.

Comment 9 Dennis Gilmore 2015-07-21 13:29:33 UTC
armv7hl on fedora is the eqivilent of armhf on debian in fedora however we use triplets different to how debian uses them. likely the mapping between fedora and debina is breaking something

armv7hl-redhat-linux-gnu is what we use for armhf  in debian I think they use arm-linux-gnueabihf
armv7l-redhat-linux-gnu is what we used for the equivalent of armel which i think they use arm-linux-gnueabi for


Dennis

Comment 10 Sergio Monteiro Basto 2015-07-21 16:28:58 UTC
Hi, 
And what is the best solution ? , instead hacking the test or hardcode dpkg .

Comment 11 Fedora End Of Life 2016-07-19 12:04:19 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 12 Sergio Monteiro Basto 2017-06-07 17:12:17 UTC
seems that also fails in ppc64le builders

Comment 13 Sergio Monteiro Basto 2017-06-07 17:22:02 UTC
*** Bug 1459615 has been marked as a duplicate of this bug. ***

Comment 14 Jan Kurik 2017-08-15 06:53:59 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 27 development cycle.
Changing version to '27'.

Comment 15 Fedora Update System 2018-09-23 03:41:42 UTC
debhelper-11.4-2.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-c68e87d8d5

Comment 16 Fedora Update System 2018-09-23 03:42:12 UTC
debhelper-11.4-2.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-9e13fa41a1

Comment 17 Fedora Update System 2018-09-23 03:42:31 UTC
debhelper-11.4-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-62921bc62c

Comment 18 Fedora Update System 2018-09-23 03:42:50 UTC
debhelper-11.4-2.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-9ecfaf9d5f

Comment 19 Fedora Update System 2018-09-23 19:47:57 UTC
debhelper-11.4-2.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-9ecfaf9d5f

Comment 20 Fedora Update System 2018-09-23 20:41:24 UTC
debhelper-11.4-2.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-c68e87d8d5

Comment 21 Fedora Update System 2018-09-23 20:47:52 UTC
debhelper-11.4-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-62921bc62c

Comment 22 Fedora Update System 2018-09-23 21:39:26 UTC
debhelper-11.4-2.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-9e13fa41a1

Comment 23 Fedora Update System 2018-10-02 19:30:52 UTC
debhelper-11.4-2.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 24 Fedora Update System 2018-10-05 17:08:36 UTC
debhelper-11.4-2.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 25 Fedora Update System 2018-10-07 21:11:13 UTC
debhelper-11.4-2.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Comment 26 Fedora Update System 2018-10-16 10:29:06 UTC
debhelper-11.4-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.